#ifndef _IMAGE_H_
#define _IMAGE_H_

// praca s obrazkami *******************************************************
class CImage
{
public:
 CImage();  // konstruktor
 ~CImage(); // destruktor

 // udaje obrazku ako ukazovatel na char
 char *getData(void) const { return(data); }

 // udaje obrazku ako ukazovatel na float
 float *getDataFloat(void) const { return(reinterpret_cast<float*>(data)); }

 // sirka a vyska obrazku
 int getWidth(void) const { return(width); }
 int getHeight(void) const { return(height); }

 // nacitanie udajov obrazku zo suboru BMP, alebo HDR
 int loadFromBmp(const char *F);
 int loadFromHdr(const char *F);

 // OpenGL format a typ
 GLenum getFormat(void) const { return(format); }
 GLenum getType(void) const { return(type); }

 // pocet Bytov na 1 pixel obrazku
 int getBpp(void) const;

 // otocenie obrazku
 void flipHorizontal(void);
 void flipVertical(void);
private:
 // udaje obrazku
 char *data;

 // sirka a vyska obrazku
 int width,height;

 // OpenGL format a typ
 GLenum format,type;

 // navratova hodnota funkcii
 int res;

 // trieda CTexture ma pristup k privatnym clenom triedy CImage
 friend class CTexture;
};

#endif
