#version 130 // GLSL verzia

// vyroba normalmapy v gimpe:
// colors - desaturate
// definovat miesta s minimalnou a maximalnou vyskou
// toto je potrebne urobit manualne, neexistuje filter
// filters - map - normalmap - vsetko nechat standardne
// duplicate layer
// nova vrstva - gaussian blur
// nova vrstva - mode - grain merge
// vytvorit tolko novych vrstiev aby sme ziskali potrebny
// vyskovy rozdiel normalmapy

uniform sampler2D base_tex_unit; // zakladna textura
uniform sampler2D hm_tex_unit;   // heightmap textura
uniform sampler2D nm_tex_unit;   // normalmap textura

// prenasane udaje
in vec2 uv;
in vec3 dir_to_light;
in vec3 tbn_dir_to_light,tbn_dir_to_eye,tbn_hv;
in float dist;
in vec4 ambient,diffuse,specular;

void main(void)
{
 vec4 amb,dif=vec4(0.0),spe=vec4(0.0);
 vec3 N,L,HV;
 float NdotL,NdotH,att=0.0,spot;
 float height,scale=0.06,bias=-0.05;
 vec2 uv_new;
 
 // normalizovany interpolovany half vektor
 HV=normalize(tbn_hv);

 // vyska z heightmap textury
 height=texture(hm_tex_unit,uv).r;
 // parallax posun
 height=height*scale+bias;
 // posunute texturovacie suradnice
 uv_new=uv+0.5*height*HV.xy;

 // normalizovana normala z normalmap textury
 N=normalize(texture(nm_tex_unit,uv_new).xyz*2.0-1.0);
 // normalizovany interpolovany vektor VERTEX -> LIGHT
 L=normalize(tbn_dir_to_light);

 // ambient
 amb=ambient;

 // diffuse a specular v zavislosti od polohy a natocenia svetelneho zdroja
 NdotL=max(dot(N,L),0.0);
 if (NdotL>0.0) {
  spot=dot(gl_LightSource[0].spotDirection,-normalize(dir_to_light));
  if (spot>gl_LightSource[0].spotCosCutoff) {
   // utlm
   att=pow(spot,gl_LightSource[0].spotExponent)/
       (gl_LightSource[0].constantAttenuation+
        gl_LightSource[0].linearAttenuation*dist+
        gl_LightSource[0].quadraticAttenuation*dist*dist);

   // diffuse
   dif=diffuse*NdotL;

   // specular
   NdotH=max(dot(N,HV),0.0);
   spe=specular*pow(NdotH,gl_FrontMaterial.shininess);
  }
 }

 // vysledna farba
 gl_FragColor=texture(base_tex_unit,uv_new)*(amb+att*(dif+spe));
}
