#version 130 // GLSL verzia

uniform sampler2D rfl_tex_unit;   // reflection textura
uniform sampler2D rfr_tex_unit;   // refraction textura
uniform sampler2D depth_tex_unit; // depth textura
uniform sampler2D nm_tex_unit;    // normalmap textura
uniform sampler2D dudv_tex_unit;  // dudv textura

// prenasane udaje
in vec2 uv1,uv2;
in vec3 tbn_dir_to_light,tbn_dir_to_eye;

void main(void)
{
 vec2 tc,dv;
 vec4 dudv,rfl,rfr,dpt,idpt;
 vec4 fresnel,ifresnel;
 vec4 spe,one=vec4(1.0);
 float i;
 vec3 N,L,E;

 // texturovacie suradnice pre reflection a refraction texturu
 tc=vec2(gl_FragCoord.x/800.0,gl_FragCoord.y/600.0); // scr_w, scr_h

 // deformacia reflection/refraction textury pomocou dudv textury
 dv=(texture(dudv_tex_unit,uv1).st);
 dudv=texture(dudv_tex_unit,dv*0.02+uv2);
 dudv=normalize(dudv*2.0-1.0)*0.005;
 tc+=dudv.xy;

 rfl=texture(rfl_tex_unit,tc);   // reflection
 rfr=texture(rfr_tex_unit,tc);   // refraction
 dpt=texture(depth_tex_unit,tc); // depth
 dpt=vec4(pow(dpt.x,32.0));
 idpt=one-dpt;

 // normalizovana normala z normalmap textury
 N=normalize(texture(nm_tex_unit,dv*0.02+uv2).xyz*2.0-1.0);
 // normalizovany interpolovany vektor VERTEX -> EYE
 E=normalize(tbn_dir_to_eye);
 // normalizovany interpolovany vektor VERTEX -> LIGHT
 L=normalize(reflect(-tbn_dir_to_light,N));

 ifresnel=vec4(dot(E,N)); // fresnel
 fresnel=one-ifresnel;
 
 rfr=rfr*ifresnel*idpt;          // refraction
 rfl=(rfl+ifresnel*dpt)*fresnel; // reflection

 i=max(0.0,dot(L,E));    // specular intensity
 spe=vec4(pow(i,128.0)); // specular

 // vysledna farba
 gl_FragColor=(rfr+rfl+spe);
}
